package unot;

public class TreePatternWriter extends PatternWriter {
	public static final String signature = "tree";
	static final String writerName = signature+" TreePatternWriter";

	DocSet docSet = null; 

	public TreePatternWriter(DocSet docSet) {
		if (docSet == null) {
			System.out.println("error: UnotPatternWriter:null docSet!");
			System.exit(1);
		}
		this.docSet = docSet;
	};

	public String getName() { return writerName; }

	String writeTree(Pattern pattern) {
		StringBuffer strBuf = new StringBuffer();

		//modified by arim for label string output
		strBuf.append("0:\t");
		String labelString =
			this.docSet.lookupLabelById(pattern.getNodeAt(0).getLabel());
		strBuf.append(labelString+"\n");

		for (int i = 1; i < pattern.getCodeSize(); i++) {
			strBuf.append(i);
			strBuf.append(":\t");

			int depth = pattern.getNodeAt(i).getDepth();
			int label = pattern.getNodeAt(i).getLabel();
			if (0 < i) {
				for (int j = 1; j < depth; j++) {
					strBuf.append("\t");
				}
				strBuf.append("  `---\t");
			}
			//Modified by arim: output label string rather than label id
			labelString = this.docSet.lookupLabelById(label);
			strBuf.append(labelString+"\n");
		}
		return strBuf.toString();
	}
}

//EOF 

